function [t,x] = EulerVerfahren2( DglFun, tspan, x0, h, par ) 
   t0 = tspan(1);   % Startpunkt des Zeitintervalls 
   te = tspan(2);   % Endpunkt des Zeitintervalls 
   t = t0:h:te;     % Zeitintervall von t0 bis te, Schrittweite h 
   anz = length(t); % Anzahl der Sttzstellen  
   
   % Vorbelegung: evtl. mehrdim. DGL 
   anzZ = length( x0 ); 
   x(anzZ,1:anz) = 0;
   
   % Startwert
   x(:,1) = x0';    
   for( n=2:anz )   % Iteration: Polygonzug-Verfahren
      % Auswertung der bergebenen Funktion DglFun
      x(:,n) = x(:,n-1) + h/2*DglFun( t(n-1), x(:,n-1), par ) + ... 
           + h/2*DglFun( t(n), x(:,n-1)+h*DglFun(t(n-1),x(:,n-1),par), par );  
   end
