%
% Laguerre-Polynome: 
%
%   n = 0: x = 1                >> laguerre( 0, 5, 1,  0 ) 
%   n = 1: x = 1 - t            >> laguerre( 1, 5, 1, -1 ) 
%   n = 2: x = 1 - 2t + t^2/2   >> laguerre( 2, 5, 1, -2 ) 
% 
function laguerre( n, tm, x0, v0 )          

  [t,y] = ode45( @LaguerreDgl, [eps,tm], [x0,v0], [], n );  
  x = y(:,1);
  plot( t, x );

end

function dy_dt = LaguerreDgl( t, y, n )           
  dy_dt(1,1) = y(2);
  dy_dt(2,1) = - (1 - t)/t *y(2) -n/t * y(1); 
end