% 
% GUI zur Funktion miniCAD.m
%    luft korrekt nur ber den Aufruf in miniCAD 
% 
function varargout = guiCAD(varargin)

% Begin initialization code - DO NOT EDIT
    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
                       'gui_Singleton',  gui_Singleton, ...
                       'gui_OpeningFcn', @guiCAD_OpeningFcn, ...
                       'gui_OutputFcn',  @guiCAD_OutputFcn, ...
                       'gui_LayoutFcn',  [] , ...
                       'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end

    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end
% End initialization code - DO NOT EDIT


% --- Executes just before guiCAD is made visible.
function guiCAD_OpeningFcn(hObject, eventdata, handles, varargin)
% Choose default command line output for guiCAD
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = guiCAD_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)

  % Zeichen zur Taste in Variable c speichern 
  c = get( hObject, 'CurrentCharacter' ); 
  
  % Starte das Picken, falls gewnschtes Zeichen gedrckt wurde 
  switch( c )
      % Gerade zeichnen
      case 'g' 
         axis( [0 10 0 10] ); 
         [x1,y1] = ginput(1);    % 1. Punkt picken
         [x2,y2] = ginput(1);    % 2. Punkt picken

         newLine( x1, y1, x2, y2 );  % Daten an CADdata bergeben
         return;
         
      % Dreieck zeichnen (3 Punkte picken, 3 Linien zeichnen)
      case 'd'
          axis( [0 10 0 10] ); 
         [x1,y1] = ginput(1); 
         [x2,y2] = ginput(1); 
         [x3,y3] = ginput(1); 

         newLine( x1, y1, x2, y2 );
         newLine( x2, y2, x3, y3 );
         newLine( x3, y3, x1, y1 );
         return;
         
      % Daten lschen
      case 'l'
          eraseData();
          
      otherwise
          return;
  end 

  return;

  
% Verwaltungsfunktion: bergibt Daten an globalen struct CADdata  
function newLine( x1, y1, x2, y2 )

  global CADdata;  % globale struct, initialisiert in miniCAD.m

  CADdata.anzPt = CADdata.anzPt + 1;  % Nr fr 1. neuen Punkt hochzhlen
  p1 = CADdata.anzPt;       % Nr. des akt. Punktes, also Punkt 1
  CADdata.pt( p1 ).x = x1;  % x-Koordinate an CADdata bergeben
  CADdata.pt( p1 ).y = y1;  % etc. 
  
  CADdata.anzPt = CADdata.anzPt + 1;  % Nr fr 2. neuen Punkt hochzhlen
  p2 = CADdata.anzPt;       % Nr. des akt. Punktes, also Punkt 2
  CADdata.pt( p2 ).x = x2;  % ...
  CADdata.pt( p2 ).y = y2; 
  
  CADdata.anzLn = CADdata.anzLn + 1;    % Nr fr neue Linie hochzhlen
  CADdata.ln( CADdata.anzLn ).p1 = p1;  % Nr des 1. Endpunkts an CADdata
  CADdata.ln( CADdata.anzLn ).p2 = p2;  % Nr des 2. Endpunkts an CADdata
  
  drawLines;    % Aufruf der unten stehenden Zeichen-Funktion
  
  return;
  
  
% alle Daten in CADdata und Grafik der Axes lschen
function eraseData()

  global CADdata;
  
  CADdata.anzPt = 0; 
  CADdata.pt = [];
  
  CADdata.anzLn = 0; 
  CADdata.ln = [];  
  
  drawLines   % leere Axes zeichnen
  
  
% Linien zeichnen, mit den aktuellen Daten aus CADdata 
function drawLines()

   global CADdata;

   % aktuelle Axes lschen
   cla
   
   hold on;   
   % alle Linien nacheinander zeichnen 
   for( n = 1:CADdata.anzLn ) 
      % 1. Punkt und 2. Punkt der Linie 
      x(1) = CADdata.pt( CADdata.ln(n).p1 ).x;  
      x(2) = CADdata.pt( CADdata.ln(n).p2 ).x; 
      y(1) = CADdata.pt( CADdata.ln(n).p1 ).y;  
      y(2) = CADdata.pt( CADdata.ln(n).p2 ).y; 
      
      % 2D-Zeichenroutine fr eine Linie mit 2 Punkten 
      plot( x,y, '-s' ); 
   end
   hold off; 
   
return;  
  

